B - Game of Sum dp1

2023-12-28 06:58
文章标签 sum game dp1

本文主要是介绍B - Game of Sum dp1,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

B - Game of Sum

点击打开链接

题意:

区间DP,以前看过一些关于区间DP的题目,但是没有做过题目,没有反应过来这是区间DP得题目。说一下题意:

给定n个石头,每个石头有一个分数,现在小伙伴A和小伙伴B进行一个游戏,小伙伴A先手,每个人每次可以选择从头或从尾取k个石头,要求出如果两个人每次都按自己最好的情况去取,最后A大于B的最大分数差是多少。

思路:

区间DP的经典题目,采用dfs枚举一下,运用sump[i][j]表示i开头j结尾的分数,dp[i][j]表示取得值,运用记忆化搜索,标记一下,有结果值得直接返回即可,一开始M开大了,一直WA。详见代码:

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
#define INF 0x7f7f7f7f
const int M = 105;
int n;
int num[M],sum[M][M],dp[M][M],vis[M][M];
int dfs(int i,int j)
{int ans=-INF;if(i>j) return 0;if(vis[i][j]) return dp[i][j];vis[i][j] = 1;for(int k=1;k<=j-i+1;k++){ans = max(ans,sum[i][j]-min(dfs(i+k,j),dfs(i,j-k)));}return dp[i][j]=ans;
}int main()
{while(~scanf("%d",&n)){if(n==0) break;memset(dp,0,sizeof(dp));memset(vis,0,sizeof(vis));for(int i=0;i<n;i++){scanf("%d",&num[i]);}for(int i=0;i<n;i++){int cnt=0;for(int j=i;j<n;j++){cnt+=num[j];sum[i][j] = cnt; ///总和}}int aans = 2*dfs(0,n-1)-sum[0][n-1];  ///dfs(0, n-1) - (Sum[0][n-1] - dp(0, n-1)printf("%d\n",aans);}return 0;
}

这篇关于B - Game of Sum dp1的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/545276

相关文章

最大流=最小割=最小点权覆盖集=sum-最大点权独立集

二分图最小点覆盖和最大独立集都可以转化为最大匹配求解。 在这个基础上,把每个点赋予一个非负的权值,这两个问题就转化为:二分图最小点权覆盖和二分图最大点权独立集。   二分图最小点权覆盖     从x或者y集合中选取一些点,使这些点覆盖所有的边,并且选出来的点的权值尽可能小。 建模:     原二分图中的边(u,v)替换为容量为INF的有向边(u,v),设立源点s和汇点t

fzu 2275 Game KMP

Problem 2275 Game Time Limit: 1000 mSec    Memory Limit : 262144 KB  Problem Description Alice and Bob is playing a game. Each of them has a number. Alice’s number is A, and Bob’s number i

如何导入sun.misc.BASE64Encoder和sum.misc.BASE64Decoder

右击项目名--->Build Path--->Configure Build Path...--->java Build Path--->Access rules:1 rule defined,added to all librar...   --->Edit --->Add...

10400 -Game Show Math

这道题的话利用了暴力深搜,尽管给了20S,但是这样还会超时,所以就需要利用回溯进行减枝,因为是DFS,所以用一个数组vis[i][j]记录是否在状态i时候取到过j值,如果取到过的话,那么直接回溯(往后搜索已经没有意义了,之前到达这个状态的时候是无法得到结果的) 还有需要注意的地方就是题目的要求,每一步的结构都在(-32000,32000)之间,所以需要一步判断,如果在这个范围外直接回溯 最后一

18. 4 Sum

题目: 解答: 与之前的三数之和的解法类似,也是先排序,然后不断剔除不可能的条件,最后两个参数,通过两头求和计算得出。 代码: class Solution {public:vector<vector<int>> fourSum(vector<int>& nums, int target) {vector<vector<int>> result;int len = nums.size

apt-get update更新源时,出现“Hash Sum mismatch”问题

转载自:apt-get update更新源时,出现“Hash Sum mismatch”问题 当使用apt-get update更新源时,出现下面“Hash Sum mismatch”的报错,具体如下: root@localhost:~# apt-get update ...... ...... W: Failed to fetch http://us.archive.ubuntu.com/ub

[LeetCode] 303. Range Sum Query - Immutable

题:https://leetcode.com/problems/range-sum-query-immutable/description/ 题目 Given an integer array nums, find the sum of the elements between indices i and j (i ≤ j), inclusive. Example: Given nums

[LeetCode] 64. Minimum Path Sum

题:https://leetcode.com/problems/minimum-path-sum/description/ 题目 Given a m x n grid filled with non-negative numbers, find a path from top left to bottom right which minimizes the sum of all numbers

[LeetCode] 404. Sum of Left Leaves

题:https://leetcode.com/problems/sum-of-left-leaves/description/ 题目 Find the sum of all left leaves in a given binary tree. Example: 3/ \9 20/ \15 7There are two left leaves in the binary t

数论 --- 费马小定理 + 快速幂 HDU 4704 Sum

Sum  Problem's Link:   http://acm.hdu.edu.cn/showproblem.php?pid=4704   Mean:  给定一个大整数N,求1到N中每个数的因式分解个数的总和。   analyse: N可达10^100000,只能用数学方法来做。 首先想到的是找规律。通过枚举小数据来找规律,发现其实answer=pow(2,n-1);